-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

if cfg.release>6 then
lib.classes["MONK"] = {}
local t,s,n
lib.classpreload["MONK"] = function()
	lib.SetPower("ENERGY")
	--lib.AddResourceBar(cfg.Power.max)
	--lib.ChangeResourceBarType(cfg.Power.type)
	lib.SetAltPower("CHI")
end
lib.classes["MONK"][10] = function() --Brewmaster
	
	cfg.chi_hit=1
	cfg.talents={
		["CHI_EXPLOSION"]=IsPlayerSpell(157676), --Chi Explosion
		["RJW"]=IsPlayerSpell(116847) --Rushing Jade Wind
	}
	
	lib.AddSpell("Keg",{121253}) --Keg Smash
	lib.FixSpell("Keg","cost")
	lib.AddSpell("Haze",{115180}) --Dizzying Haze
	lib.AddSpell("Breath",{115181}) -- Breath of Fire
	lib.AddAura("Breath",123725,"debuff","target") -- Breath of Fire
	lib.AddSpell("Guard",{115295},true) -- Guard
	lib.AddAura("Shuffle",115307,"buff","player") -- Shuffle
	lib.SetTrackAura("Shuffle")
	lib.SetAuraFunction("Shuffle","OnApply",function()
		lib.UpdateTrackAura(cfg.GUID["player"],0)
	end)
	lib.SetAuraFunction("Shuffle","OnFade",function()
		lib.UpdateTrackAura(cfg.GUID["player"])
	end)
	
	lib.AddSpell("Brew",{115308},true) -- Elusive Brew
	lib.AddAura("Brew_stacks",128939,"buff","player") -- Elusive Brew stacks
	lib.AddSpell("Purifying",{119582}) -- Purifying Brew
	lib.AddAuras("Stagger",{124274,124273},"debuff","player","player")
	
	lib.SetTrackDOT("Breath")
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Touch of Death")
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Detocs")
	table.insert(cfg.plistdps,"LotWT_nobuff")
	table.insert(cfg.plistdps,"Xuen")
	table.insert(cfg.plistdps,"Guard_noGuard")
	table.insert(cfg.plistdps,"Keg_nomax")
	table.insert(cfg.plistdps,"Expel_nomax")
	table.insert(cfg.plistdps,"Jab_nomax")
	table.insert(cfg.plistdps,"Serenity_buffed")
	if cfg.talents["CHI_EXPLOSION"] then
		table.insert(cfg.plistdps,"CE_Stagger")
	else
		table.insert(cfg.plistdps,"Purifying_Stagger")
	end
	table.insert(cfg.plistdps,"Kick_noShuffle")
	table.insert(cfg.plistdps,"Sphere_noSphere")
	table.insert(cfg.plistdps,"Brew_noBrew")
	table.insert(cfg.plistdps,"Tiger Palm_noPower")
	--
	--table.insert(cfg.plistdps,"Breath_noBreath")
	table.insert(cfg.plistdps,"Kick_3")
	table.insert(cfg.plistdps,"Chi-Wave")
	if IsPlayerSpell(117967) then
		table.insert(cfg.plistdps,"Tiger Palm")
	end
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Kick")
	table.insert(cfg.plistaoe,"Detocs")
	table.insert(cfg.plistaoe,"LotWT_nobuff")
	table.insert(cfg.plistaoe,"Keg_nomax")
	table.insert(cfg.plistaoe,"Spin_nomax")
	if cfg.talents["RJW"] then
		table.insert(cfg.plistaoe,"Expel_nomax")
		table.insert(cfg.plistaoe,"Jab_aoe")
	end
	if not cfg.talents["CHI_EXPLOSION"] then
		table.insert(cfg.plistaoe,"Purifying_Stagger")
	end
	table.insert(cfg.plistaoe,"Tiger Palm_noPower")
	table.insert(cfg.plistaoe,"Sphere_noSphere")
	table.insert(cfg.plistaoe,"Kick_noShuffle_aoe")
	table.insert(cfg.plistaoe,"Guard_noGuard")
	if cfg.talents["CHI_EXPLOSION"] then
		table.insert(cfg.plistaoe,"CE_aoe")
	else
		table.insert(cfg.plistaoe,"Breath_noBreath")
	end
	table.insert(cfg.plistaoe,"Brew_noBrew")
	table.insert(cfg.plistaoe,"Chi-Wave")
	if IsPlayerSpell(117967) then
		table.insert(cfg.plistaoe,"Tiger Palm")
	end
	table.insert(cfg.plistaoe,"end")
	
	cfg.plist=cfg.plistdps
	
	
	cfg.case = {
		["Guard_noGuard"] = function()
			if lib.GetUnitHealth("player","percent")>cfg.healpercent then return nil end
			return lib.SimpleCDCheck("Guard",lib.GetAura({"Guard"})-9)
		end,
		["Kick_noShuffle"] = function()
			if cfg.AltPower.now<2 then return nil end
			return lib.SimpleCDCheck("Kick",lib.GetAura({"Shuffle"})-1.8)
		end,
		["Kick_noShuffle_aoe"] = function()
			if cfg.AltPower.now<2 then return nil end
			return lib.SimpleCDCheck("Kick",lib.GetAura({"Shuffle"}))
		end,
		["Brew_noBrew"] = function()
			if lib.GetAuraStacks("Brew_stacks")>=9 then
				return lib.SimpleCDCheck("Brew",lib.GetAura({"Brew"}))
			end
			return nil
		end,
		["Breath_noBreath"] = function()
			return lib.SimpleCDCheck("Breath",lib.GetAura({"Breath"})-2.4)
		end,
		["Purifying_Stagger"] = function()
			if lib.GetAuras("Stagger")>0 then return lib.SimpleCDCheck("Purifying") end
			return nil
		end,
		["CE_Stagger"] = function()
			if cfg.AltPower.now>=3 and lib.GetAuras("Stagger")>0 then
				return lib.SimpleCDCheck("Kick")
			end
			return nil
		end,
		["Keg_nomax"] = function()
			if cfg.AltPower.max>=cfg.AltPower.now+2 then
				return lib.SimpleCDCheck("Keg")
			end
			return nil
		end,
		["Jab_nomax"] = function()
			if cfg.AltPower.max<cfg.AltPower.now+cfg.chi_hit+lib.GetAuraStacks("Power_Strikes") then
				return nil
			end
			if lib.GetSpellCD("Keg")>=lib.Time2Power(lib.GetSpellCost("Keg")+lib.GetSpellCost("Jab")-cfg.Power.regen) then
				return lib.SimpleCDCheck("Jab",lib.GetAura({"Serenity"}))
			end
			return nil
		end,
		["Jab_aoe"] = function()
			if cfg.AltPower.max<cfg.AltPower.now+cfg.chi_hit+lib.GetAuraStacks("Power_Strikes") then
				return nil
			end
			if lib.GetSpellCD("Spin")>=lib.Time2Power(lib.GetSpellCost("Spin")+lib.GetSpellCost("Jab")) then
				return lib.SimpleCDCheck("Jab")
			end
			return nil
		end,
		["Expel_nomax"] = function()
			if cfg.AltPower.max>=cfg.AltPower.now+cfg.chi_hit+lib.GetAuraStacks("Power_Strikes") and lib.GetUnitHealth("player","percent")<=cfg.healpercent then
				return lib.SimpleCDCheck("Expel")
			end
			return nil
		end
	}
	
	cfg.mode = "dps"
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
	end

	return true
end
lib.classes["MONK"][3] = function() --Windwalker
	cfg.chi_hit=2
	cfg.norepeat=true
	cfg.talents={
		["Serenity"]=IsPlayerSpell(152173), --Chi Explosion
	}
	
	lib.AddSpell("Rising Sun Kick",{107428}) --Rising Sun Kick
	lib.AddAura("Rising Sun Kick",130320,"debuff","target") -- Rising Sun Kick
	lib.AddAura("Blackout Kick!",116768,"buff","player")
	lib.AddSpell("Tiger Palm",{100780}) --Tiger Palm
	lib.AddSpell("Fists of Fury",{113656}) -- Fists of Fury
	lib.AddSpell("Spinning Crane Kick",{101546},true)
	lib.AddSpell("Rushing Jade Wind",{116847},true)
	lib.AddSpell("Whirling Dragon Punch",{152175})
	lib.AddSpell("Energizing Elixir",{115288})
	if cfg.talents["Serenity"] then
		lib.AddSpell("Serenity",{152173},true)
	else
		lib.AddSpell("Storm, Earth, and Fire",{137639},true)
	end
	
	
	
	
	lib.OnHaste = function()
		if cfg.spells["Fists of Fury"] then
			cfg.spells["Fists of Fury"].channel=lib.HastedCast(4)
		end
	end
	
	lib.AddAura("Hit Combo",196741,"buff","player")
	lib.SetTrackAura("Hit Combo")
	lib.SetAuraFunction("Hit Combo","OnStacks",function()
		lib.UpdateTrackAura(cfg.GUID["player"],lib.GetAuraStacks("Hit Combo")>0 and lib.GetAuraStacks("Hit Combo") or nil)
	end)
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Detocs")
	table.insert(cfg.plistdps,"Xuen")
	
	table.insert(cfg.plistdps,"Touch of Death")
	table.insert(cfg.plistdps,"Storm, Earth, and Fire")
	table.insert(cfg.plistdps,"Serenity")
	table.insert(cfg.plistdps,"Energizing Elixir")
	table.insert(cfg.plistdps,"Rushing Jade Wind_Serenity")
	table.insert(cfg.plistdps,"Whirling Dragon Punch")
	table.insert(cfg.plistdps,"Fists of Fury")
	table.insert(cfg.plistdps,"Rising Sun Kick")
	table.insert(cfg.plistdps,"Rushing Jade Wind2")
	table.insert(cfg.plistdps,"Chi-Wave")
	table.insert(cfg.plistdps,"Chi Burst")
	table.insert(cfg.plistdps,"Blackout Kick")
	table.insert(cfg.plistdps,"Tiger Palm")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Kick")
	table.insert(cfg.plistaoe,"Detocs")
	table.insert(cfg.plistaoe,"end")
	cfg.plistaoe=nil

	cfg.plist=cfg.plistdps

	cfg.case = {
		["Energizing Elixir"] = function()
			if cfg.Power.now<cfg.Power.max and cfg.AltPower.now<=1 then
				return lib.SimpleCDCheck("Energizing Elixir",lib.GetAura({"Serenity"}))
			end
			return nil
		end,
		["Tiger Palm"] = function()
			if cfg.AltPower.max-cfg.AltPower.now>=2+lib.GetAuraStacks("Power_Strikes") then
				return lib.SimpleCDCheck("Tiger Palm",lib.GetAura({"Serenity"}))
			end
			return nil
		end,
		["Blackout Kick"] = function()
			if lib.GetAura({"Serenity"})>lib.GetSpellCD("Blackout Kick") then
				return lib.SimpleCDCheck("Blackout Kick")
			else
				if cfg.AltPower.now>1 or lib.GetAura({"Blackout Kick!"})>lib.GetSpellCD("Blackout Kick") then
					return lib.SimpleCDCheck("Blackout Kick")
				end
			end
			return nil
		end,
		["Rushing Jade Wind_Serenity"] = function()
			if lib.GetAura({"Serenity"})>lib.GetSpellCD("Rushing Jade Wind") then
				return lib.SimpleCDCheck("Rushing Jade Wind")
			end
			return nil
		end,
		["Rushing Jade Wind2"] = function()
			if cfg.AltPower.now>1 then
				return lib.SimpleCDCheck("Rushing Jade Wind")
			end
			return nil
		end,
		["Storm, Earth, and Fire"] = function()
			return lib.SimpleCDCheck("Storm, Earth, and Fire",lib.GetAura({"Storm, Earth, and Fire"}))
		end,
	}
	
	lib.AddRangeCheck({
	{"Tiger Palm",nil},
	--{"Howling Blast",{0,0,1,1}},
	})
	--cfg.mode = "dps"
	
	--cfg.spells_aoe={"Spin"}
	--cfg.spells_single={"Kick"}
	return true
end


lib.classpostload["MONK"] = function()
	cfg.healpercent=80
	lib.AddDispellPlayer("Detocs",{115450},{"Disease","Poison"}) --Detocs
	lib.SetInterrupt("Kick",{116705}) --Spear Hand Strike
	lib.AddSpell("Sphere",{124081},true) -- Zen Sphere
	--lib.AddAura("Sphere",124081,"buff","player") -- Zen Sphere
	cfg.case["Sphere_noSphere"] = function()
		return lib.SimpleCDCheck("Sphere",lib.GetAura({"Sphere"}))
	end
	
	lib.AddSpell("Xuen",{123904}) --Invoke Xuen, the White Tiger
	
	--ib.AddSpell("Tiger Palm",{100787}) --Tiger Palm
	lib.AddAura("Power",125359,"buff","player") -- Tiger Power
	cfg.case["Tiger Palm_noPower"] = function()
		return lib.SimpleCDCheck("Tiger Palm",lib.GetAura({"Power"})-6)
	end
	
	lib.AddSpell("Blackout Kick",{100784}) --Blackout Kick
	cfg.case["Kick_3"] = function()
		if cfg.AltPower.now>=3 then -- if cfg.AltPower.max-cfg.AltPower.now<=2 then
			return lib.SimpleCDCheck("Kick")
		end
		return nil
	end
	
	cfg.case["CE_aoe"] = function()
		if cfg.AltPower.now>=4 then
			return lib.SimpleCDCheck("Kick")
		end
		return nil
	end
	
	lib.AddSpell("Chi-Wave",{115098}) -- Chi-Wave
	cfg.case["Chi-Wave"] = function()
		return lib.SimpleCDCheck("Chi-Wave",lib.GetAura({"Serenity"}))
	end
	lib.AddSpell("Chi Burst",{123986})
	cfg.case["Chi Burst"] = function()
		return lib.SimpleCDCheck("Chi Burst",lib.GetAura({"Serenity"}))
	end
	
	lib.AddSpell("Touch of Death",{115080},true) -- Touch of Death
	

	lib.AddSpell("LotWT",{116781}) -- Legacy of the White Tiger
--	lib.AddAura("LotWT",116781,"buff","player") -- Legacy of the White Tiger
	lib.AddSpell("Fortifying",{115203}) -- Fortifying Brew
	lib.AddAura("Fortifying",120954,"buff","player")
	
	lib.AddSpell("Zen",{115176},true) -- Zen Meditation
	
	
	cfg.case["Fortifying"] = function()
		if not lib.hardtarget() then return nil end
		if lib.GetAura({"Touch of Death"})>0 then
			return lib.SimpleCDCheck("Fortifying")
		end
		return nil
	end
	
	cfg.case["LotWT_nobuff"] = function()
		--return nil
		return lib.SimpleCDCheck("LotWT",math.min(lib.GetAuras("Stats"),lib.GetAuras("Crit")))
	end
	lib.AddAura("Power_Strikes",129914,"buff","player")
	lib.AddSpell("Jab",{115693,115695,115687,115698,108557,100780})
	lib.FixSpell("Jab","cost")
	lib.AddSpell("Expel",{115072}) -- Expel Harm
	lib.FixSpell("Expel","cost")

	
	lib.SetAuraFunction("Spin2","OnApply",function()
		cfg.nousecheck=true
	end)
	lib.SetAuraFunction("Spin2","OnFade",function()
		cfg.nousecheck=false
	end)
	cfg.case["Jab_aoe"] = function()
		if cfg.AltPower.max>=cfg.AltPower.now+cfg.chi_hit+lib.GetAuraStacks("Power_Strikes") and lib.GetSpellCD("Spin")>=lib.Time2Power(lib.GetSpellCost("Spin")+lib.GetSpellCost("Jab")) then
			return lib.SimpleCDCheck("Jab")
		end
		return nil
	end
	cfg.case["Expel_nomax"] = function()
		if cfg.AltPower.max>=cfg.AltPower.now+cfg.chi_hit+lib.GetAuraStacks("Power_Strikes") and lib.GetUnitHealth("player","percent")<=cfg.healpercent then
			return lib.SimpleCDCheck("Expel")
		end
		return nil
	end
	cfg.case["Spin_nomax"] = function()
		if cfg.AltPower.max>=cfg.AltPower.now+cfg.chi_hit+lib.GetAuraStacks("Power_Strikes") then
			return lib.SimpleCDCheck("Spin")
		end
		return nil
	end
	
	cfg.case["Serenity_buffed"] = function()
		if lib.GetAura({"Power"})>lib.GetSpellCD("Serenity")+10 
		and cfg.AltPower.now>=3 and (lib.Time2Power(lib.GetSpellCost("Jab"))>lib.GetSpellCD("Serenity")
		or cfg.AltPower.now==cfg.AltPower.max) then
			return lib.SimpleCDCheck("Serenity",lib.GetAura({"EB"}))
		end
		return nil
	end
		
	cfg.spells_aoe={"Spin"}
	if cfg.talents["RJW"] then
		cfg.spells_single={}
	else
		cfg.spells_single={"Jab"}
	end
	
	lib.CD = function()
		lib.CDadd("Kick")
		lib.CDadd("Detocs")
		lib.CDadd("Touch of Death")
		lib.CDadd("Serenity")
		lib.CDadd("Storm, Earth, and Fire")
		if cfg.spells["Xuen"] then
			lib.CDadd("Xuen")
			lib.CDaddTimers("Xuen","Xuen",function(self, event, unitID,spellname, rank, castid, spellID)
				if event=="UNIT_SPELLCAST_SUCCEEDED" and unitID=="player" and spellID==lib.GetSpellId("Xuen") then
					CooldownFrame_SetTimer(self.cooldown,GetTime(),45,1)
				end
			end
			,{"UNIT_SPELLCAST_SUCCEEDED"})
		end
		lib.CDadd("TB")
		lib.CDadd("Chi_Brew")
		
		lib.CDadd("Fists of Fury")
		lib.CDadd("Brew")
		lib.CDadd("Zen")
		lib.CDturnoff("Zen")
		lib.CDadd("Karma")
		lib.CDturnoff("Karma")
		lib.CDadd("Fortifying")
		lib.CDturnoff("Fortifying")
		lib.CDadd("Guard")
		lib.CDadd("EB")
		lib.CDadd("Chi-Wave")
		lib.CDadd("Sphere")
		
	end
end
end